package com.eactive.eai.agent.property;

import com.eactive.eai.agent.command.Command;
import com.eactive.eai.agent.command.CommandException;
import com.eactive.eai.common.property.PropGroupVO;
import com.eactive.eai.common.property.PropManager;
import com.eactive.eai.common.util.Logger;

/**
* 1. 기능 : Running중인 EAI Server의 메모리에 로딩된 PropManager의 정보 변경
* 2. 처리 개요 : PropManager에서 해당 PropGroupVO 의 데이터 수정
* 3. 주의사항
*
* @author
* @version  v 1.0.0
* @see  관련 기능을 참조
* @since
*/
public class UpdatePropertyCommand extends Command
{

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
    * 1. 기능 : UpdatePropertyCommand 생성자
    * 2. 처리 개요 :
    * 3. 주의사항
    *
    * @param
    * @return
    * @exception
    **/
    public UpdatePropertyCommand(String name) {
    	super(name);
    }

    /**
    * 1. 기능 :  PropManager에서 해당 PropGroupVO 의 데이터 수정
    * 2. 처리 개요 : PropGroupVO EAISvrInstNm이 DEFAULT_SERVER(ALL) 이거나  LocalServer인 경우
    *           PropManager에서 해당 PropGroupVO 의 데이터 수정
    * 3. 주의사항
    *
    * @param
    * @return
    * @exception    CommandException
    **/
    public Object execute() throws CommandException
    {
        Logger logger = Logger.getLogger(Logger.LOGGER_DEFAULT);
        logger.info(this.name + " Agent 가 호출되었습니다.");

        if ( args == null || !(args instanceof String) ) {
            String msg = makeException("BECEAICAG001", null);
            logger.error(msg);
            throw new CommandException(msg);
        }

        try {
        	
            PropGroupVO vo = PropManager.getInstance().getPropGroupVOinDB((String)args);

            logger.info(this.name +": (Agent Argument) PropGroupName=["+vo.getName()+"]");

            PropManager.getInstance().setPropGroupVO((String)args, vo);
            
            /**
             * FileLogger log.level modify
             */
            if(((String)args).startsWith("FileLogger{")){
            	com.eactive.eai.common.util.Logger.reloadLogLevel((String)args);
            }                

			logger.info(this.name + " Agent 가 성공적으로 완료되었습니다.");
            return "sucess";

        } catch (Exception e) {
            String msg = makeException("BECEAICAG002", e);
            logger.error(msg, e);
            throw new CommandException(msg);
        }
    }

}
